-- rActionButtonStyler by Roth, modified.

local F, C, L = unpack(select(2, ...))

local function stylebars(self)
	if not self.styled and self:GetParent() and self:GetParent():GetName() ~= "MultiCastActionBarFrame" and self:GetParent():GetName() ~= "MultiCastActionPage1" and self:GetParent():GetName() ~= "MultiCastActionPage2" and self:GetParent():GetName() ~= "MultiCastActionPage3" then
		local action = self.action
		local name = self:GetName()
		local bu  = _G[name]
		local ic  = _G[name.."Icon"]
		local co  = _G[name.."Count"]
		local bo  = _G[name.."Border"]
		local ho  = _G[name.."HotKey"]
		local na  = _G[name.."Name"]
		local fl  = _G[name.."Flash"]
		local nt  = _G[name.."NormalTexture"]

		nt:SetHeight(bu:GetHeight())
		nt:SetWidth(bu:GetWidth())
		nt:SetPoint("Center", 0, 0)

		bo:Hide()
		bo.Show = F.dummy

		co:SetFont(C.media.font, 8, "OUTLINEMONOCHROME")
		co:ClearAllPoints()
		co:SetPoint("TOP", 0, -2)

		if C.general.hotkey == true then
			ho:ClearAllPoints()
			ho:SetPoint("BOTTOM")
			ho:SetFont(C.media.font, 8, "OUTLINEMONOCHROME")
			ho:SetJustifyH("CENTER")
		else
			ho:Hide()
			ho.Show = F.dummy
		end

		na:Hide()

		bu:SetCheckedTexture(bu:GetHighlightTexture())
		bu:SetNormalTexture("")

		ic:SetTexCoord(.08, .92, .08, .92)
		ic:SetPoint("TOPLEFT", bu, "TOPLEFT", 1, -1)
		ic:SetPoint("BOTTOMRIGHT", bu, "BOTTOMRIGHT", -1, 1)

		nt.SetHeight = F.dummy
		nt.SetWidth = F.dummy
		fl.SetTexture = F.dummy
		bu.SetHighlightTexture = F.dummy
		bu.SetPushedTexture = F.dummy
		bu.SetCheckedTexture = F.dummy
		bu.SetNormalTexture = F.dummy
		co.SetPoint = F.dummy
		co.SetFont = F.dummy
		ho.ClearAllPoints = F.dummy
		ho.SetPoint = F.dummy
		ho.SetFont = F.dummy
		ho.SetJustifyH = F.dummy

		local bg = CreateFrame("Frame", nil, self)
		bg:SetBackdrop({ 
			edgeFile = C.media.backdrop, 
			edgeSize = 1, 
		})
		bg:SetBackdropBorderColor(0, 0, 0)
		bg:SetAllPoints(self)
		bg:SetFrameStrata("LOW")

		self.styled = true
	end
end

local function stylepet()
	for i = 1, NUM_PET_ACTION_SLOTS do
		local name = "PetActionButton"..i
		local bu  = _G[name]
		local ic  = _G[name.."Icon"]
		local nt  = _G[name.."NormalTexture2"]

		nt:SetHeight(bu:GetHeight())
		nt:SetWidth(bu:GetWidth())
		nt:SetPoint("Center", 0, 0)

		bu:SetCheckedTexture(C.media.questborder)
		bu:SetNormalTexture("")

		ic:SetTexCoord(0.08, 0.92, 0.08, 0.92)
		ic:SetPoint("TOPLEFT", bu, "TOPLEFT", 1, -1)
		ic:SetPoint("BOTTOMRIGHT", bu, "BOTTOMRIGHT", -1, 1)
	end  
end

for i=1, NUM_PET_ACTION_SLOTS do
	local name = "PetActionButton"..i
	local bu  = _G[name]

	local pbg = CreateFrame("Frame", nil, bu)
	pbg:SetBackdrop({ 
		edgeFile = C.media.backdrop, 
		edgeSize = 1, 
	})
	pbg:SetBackdropBorderColor(0, 0, 0)
	pbg:SetAllPoints(bu)
	pbg:SetFrameStrata("LOW")
end

local function styleshift()
	if C.general.shapeshift ~= true then return end
	for i = 1, NUM_SHAPESHIFT_SLOTS do
		local name = "ShapeshiftButton"..i
		local bu  = _G[name]
		local ic  = _G[name.."Icon"]
		local nt  = _G[name.."NormalTexture"]

		--nt:SetAllPoints(bu)

		bu:SetCheckedTexture(C.media.questborder)
		bu:SetNormalTexture("")

		ic:SetTexCoord(0.08, 0.92, 0.08, 0.92)
		ic:SetPoint("TOPLEFT", bu, "TOPLEFT", 1, -1)
		ic:SetPoint("BOTTOMRIGHT", bu, "BOTTOMRIGHT", -1, 1)
	end
end

if C.general.shapeshift == true then
	for i=1, NUM_SHAPESHIFT_SLOTS do
		local name = "ShapeshiftButton"..i
		local bu  = _G[name]

		local sbg = CreateFrame("Frame", nil, bu)
		sbg:SetBackdrop({ 
			edgeFile = C.media.backdrop, 
			edgeSize = 1, 
		})
		sbg:SetBackdropBorderColor(0, 0, 0)
		sbg:SetAllPoints(bu)
		sbg:SetFrameStrata("LOW")
	end
end

hooksecurefunc("ActionButton_Update", stylebars)
hooksecurefunc("PetActionBar_Update", stylepet)
if C.general.shapeshift == true then
	hooksecurefunc("ShapeshiftBar_Update", styleshift)
	hooksecurefunc("ShapeshiftBar_UpdateState", styleshift)
end